module Segurocomar
  module Core
    module Cars
      def get_car_brands(attrs={})
        results = get_request('/car_brands', attrs)

        results[:body].map { |r| Segurocomar::Entity::CarBrand.new(r) }
      end

      def get_cars(car_brand_id, year)
        results = get_request('/cars', { car_brand_id: car_brand_id, year: year })

        results[:body].map { |r| Segurocomar::Entity::Car.new(r) }
      end

      def get_car_versions(car_id, year)
        results = get_request('/car_versions', { car_id: car_id, year: year })

        results[:body].map { |r| Segurocomar::Entity::CarVersion.new(r) }
      end

      def get_car_version_price(car_version_id, year)
        result = get_request("/car_versions/#{car_version_id}/price", { year: year })
        Segurocomar::Entity::CarVersionPrice.new(result[:body])
      end
    end
  end
end

