module Segurocomar
  module Core
    module Insurance
      def get_insurers(insurable_kind)
        results = get_request("/insurers", { insurable_kind: insurable_kind })

        results[:body].map { |r| Segurocomar::Entity::Insurer.new(r) }
      end

      def get_insurer(id, insurable_kind)
        result = get_request("/insurers/#{id}", { insurable_kind: insurable_kind })

        Segurocomar::Entity::Insurer.new(result[:body])
      end

      def get_products(args={})
        results = get_request("/products", args)

        results[:body].map { |r| Segurocomar::Entity::Product.new(r) }
      end

      def get_product(id)
        result = get_request("/products/#{id}")

        Segurocomar::Entity::Product.new(result[:body])
      end
    end
  end
end

