module Segurocomar
  module Core
    module Misc
      def get_insurable_years
        results = get_request('/valid_years')

        results[:body].map { |r| Segurocomar::Entity::InsurableYear.new(r) }
      end

      def get_provinces
        results = get_request('/provinces')

        results[:body].map { |r| Segurocomar::Entity::Province.new(r) }
      end

      def get_localities(args={})
        results = get_request('/localities', args)

        results[:body].map { |r| Segurocomar::Entity::Locality.new(r) }
      end

      def get_ad_campaign(referral_code)
        results = get_request("/ad_campaigns/#{referral_code}")

        Segurocomar::Entity::AdCampaign.new(results[:body])
      end
    end
  end
end

