module Segurocomar
  module Core
    module Quotes
      def create_quote(quote_data={})
        results = post_request('/quotes', quote_data)

        results[:body]
      end

      def get_quote(quote_code)
        result = get_request("/quotes/#{quote_code}")
        Segurocomar::Entity::Quote.new(result[:body])
      end

      def get_quote_insurers(quote_code)
        results = get_request("/quotes/#{quote_code}/insurers")

        results[:body].map { |r| Segurocomar::Entity::Insurer.new(r) }
      end

      def get_quote_products(quote_code, product_ids=nil)
        results = get_request("/quotes/#{quote_code}/quote_products", {
          product_ids: product_ids.join(',')
        })

        results[:body].map { |r| Segurocomar::Entity::QuoteProduct.new(r) }
      end

      def hire_quote_product(quote_id, product_id)
        result = post_request("/quotes/#{quote_id}/hire_product/#{product_id}")

        Segurocomar::Entity::QuoteProduct.new(result[:body])
      end
    end
  end
end

