module Segurocomar
  module Entity
    class Insurer
      def self.attr_list
        [:id, :code, :name, :products]
      end

      attr_reader *attr_list

      def initialize(attributes={})
        attributes.each do |k, v|
          if k.to_s == 'products'
            self.products = v.map { |p| Product.new(p) }
          elsif self.respond_to?(k)
            self.send("#{k}=", v)
          end
        end
      end

      def get_product(code)
        products.find { |x| x.code.to_s == code.to_s }
      end

      private

      attr_writer *attr_list
    end
  end
end
